
library(Iso)
##figure out the dose for next patient.

sugglevfun <- function (havemin, possesc, target, userind, pi, nvec, yvec)
{		#only one has mini loss
		if (sum(havemin)==1)
		{	sugglev <- userind[havemin]
		}
		
		#more than 1 mini loss
		if (sum(havemin) > 1)
		 {	#mini loss has ties
			posslev <- userind [havemin]			
			if (all(pi[posslev] >= target)) #doses with miniloss all have pi larger than target
			{	sugglev <- min(posslev)
			}
 			else	#some dose with pi less than target

			{	posslev2 <-  posslev [pi[posslev] < target]
				sugglev <- max(posslev2)
			}
		}

		#if the sugglev less than target and some of its possible esclation haven't been tried, we need to esclate.

		len <- length(possesc[[sugglev]])
		if (len==1)	poss <- possesc[[sugglev]][[1]]
		if (len==2)	poss <- c(possesc[[sugglev]][[1]], possesc[[sugglev]][[2]])		

		if (pi[sugglev] < target && any (nvec[poss] == 0)) 
		{	posslev <- possesc[[sugglev]] #need to esclate.  
			len <- length(posslev)	#check it is 1 or 2 direction choice
		
			posslev2 <- list()
			t <- match(0, nvec[posslev[[1]]])  #find the 1st not tried dose in the 1st direction.
			if (!is.na(t))	posslev2[[1]] <- posslev[[1]][t]
		

			if (len==2)
			{	t2 <- match(0, nvec[posslev[[2]]])  #find the 1st not tried dose in the 2nd direction.
				if(!is.na(t2))
				{	if (!is.na(t))	posslev2[[2]]<- posslev[[2]][t2]
				}
				else posslev2[[2]] <- posslev[[2]][t2]

			}

			
			nesc <- length(posslev2)

			if (nesc==1) sugglev <- posslev2[[1]][1]
			
			if (nesc==2)
			{	if (is.na(posslev2[[2]])) sugglev <- posslev2[[1]][1]

				if(!is.na(posslev2[[2]])) 
				{	tmp <- runif(nesc, min=0, max=1)
					sugglev <- posslev2[[match(T,rank(tmp)== nesc)]][1]
				}
			}
		}

	sugglev
}

mcdesignimp<-function(yvec,nvec,target,possrd,possesc,a0,b0,gam,cl)
{

	len <- length(yvec)
	userind <- seq(1, len, 1)
	mtd<-0
	a <- length(possord[1,])  #decide how many possible orders.
	study=1

#get pava estimate
		x <- (yvec+avec)/(nvec+avec+bvec)
		y <- cbind(x, nvec, 1:len)

		pi.1<-rep(0, len)

	
		#print(yvec)
		#print(nvec)
		#print(round(x, 2))

		for ( m in 1:a)
		{	y2 <- y[possord[,m],]
			x2 <- y2[,1]
			wt <- y2[,2]
			pi0 <- pava(x2, w=wt)	
			tmp <- sort(y2[,3], index.return=T)
			pi.1 <- pi.1 + pi0[tmp[[2]]]
			#print(round(pi0[tmp[[2]]], 2))		

		}

		pi <- round(pi.1/a,2)  #pi is an average of estimates from the a types of possible orders.
		#print(round(pi, 2))

		postrisk1<-1 - pbeta(target, yvec[5] + a0, nvec[5] - yvec[5] + b0)
		postrisk2<-1 - pbeta(target, yvec[6] + a0, nvec[6] - yvec[6] + b0) 
		if(postrisk1 > cl & postrisk2 > cl){
			study=2
		}

		lossvec=rep(1,len)
		if(study==1){
			lossvec[5:23]=ifelse(pi[5:23] > target, (1-gam)*(pi[5:23]-target), gam*(target-pi[5:23]))
		}
		if(study==2){
			lossvec[1:4]=ifelse(pi[1:4] > target, (1-gam)*(pi[1:4]-target), gam*(target-pi[1:4]))
		}

		#lossvec	

		##calculate loss function
		#lossvec <- ifelse(pi > target, (1-gam)*(pi-target), gam*(target-pi))
		minloss <- min(lossvec)
		havemin <- lossvec==minloss
		if(study==2 & sum(nvec[1:4])==0){
			sugglev=1
		} else{
			sugglev <- sugglevfun(havemin, possesc, target, userind, pi, nvec, yvec)
		}
		suggprob <- pi[sugglev]
	
	
		#print(yvec)
		#print(nvec)
		#print(pi)
		#print(paste('suggested level', sugglev))


		##at this point, the cycle is going on and a dose has been decided for the next patient
		## generate an outcome for this new patient and add the outcome to the stop criteria
		
		currstudy<-ifelse(study==1,"NO","YES")
   		currlev<-ifelse(1 - pbeta(target, yvec[1] + a0, nvec[1] - yvec[1] + b0) > .8,"STOP STUDY",sugglev)


    cat("Date and time:                          	", format(Sys.time()), sep="\t",  "\n");
    cat("Combination labels in simulation studies:	", 1:length(yvec), sep="\t",   "\n");
    cat("Number of dose-limiting toxicities (DLTs):   ", yvec, sep="\t",   "\n");
    cat("Number of patients evaluated for DLT:    	", nvec, sep="\t",   "\n");
    cat("Estimated DLT probabilities:            	", round(pi,3), sep="\t",  "\n");
    cat("Permanant shift to left column:          	", currstudy, sep="\t",  "\n");
    cat("Target DLT rate:                         	", target, sep="\t",  "\n");
    cat("Recommended combination:                  	", currlev, sep="\t",  "\n");


}

		


#######################################################
#
#	Input
#
########################################################
target<-1/5
###calculate prior
x<-target*2
mu<-target
#a<-mu*b/(1-mu)
u<-0.95

f<-function(b){
	pbeta(x,mu*b/(1-mu),b)-u
}
b0<-uniroot(f,c(0.0001,100))$root
a0<-mu*b0/(1-mu)
round(c(a0,b0),2)


nlev<-23
possesc<-list(2,3,4,4,c(7,8),c(8,9),c(10,11),c(11,12),c(12,13),c(14,15),c(15,16),c(16,17),17,18,c(18,19),c(19,20),20,
		21,c(21,22),22,23,23,23) ##need to be length 1 or 2
possord<-matrix(nrow=23,ncol=6)
possord[,1]<-c(1,2,3,4,6,5,7,8,9,13,12,11,10,14,15,16,17,20,19,18,21,22,23)  
possord[,2]<-c(1,2,3,4,5,6,9,8,7,10,11,12,13,17,16,15,14,18,19,20,22,21,23)  
possord[,3]<-c(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23)
possord[,4]<-c(1,2,3,4,6,5,9,8,7,13,12,11,10,17,16,15,14,20,19,18,22,21,23)
possord[,5]<-c(1,2,3,4,6,9,13,5,8,12,17,7,11,16,20,10,15,19,22,14,18,21,23)
possord[,6]<-c(1,2,3,4,5,7,10,14,6,8,11,15,18,9,12,16,19,21,13,17,20,22,23)
nmax<-60
avec<-a0
bvec<-b0
gam<-0.5
cl<-0.7

##Enter number of observed DLTs at each combo
yvec=c(0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,2,2,2,0,1,2,2,1)
 
##Enter the number of patients evaluated for DLT at each combo
nvec=c(0,0,0,0,1,0,2,2,9,4,2,0,3,3,2,9,4,4,1,4,3,6,1)

##Enter number of observed DLTs at each combo
yvec=c(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1)
 
##Enter the number of patients evaluated for DLT at each combo
nvec=c(0,0,0,0,1,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,1,0,1)

mcdesignimp(yvec,nvec,target,possord,possesc,a0,b0,gam,cl)



